<?php
/***********************************************************************************
Script purpose: Building a 3n-1 sequence from 1, 5 or 17 (using the GMP libary)
Written by:		Joerg Drescher, iovialis@gmx.de
Date: 			31.03.2022
Link: 			https://3n-1.de/build_3n-1.php
Lizence: 		CC BY-SA - https://creativecommons.org/licenses/by-sa/4.0/
***********************************************************************************/
error_reporting (E_ALL ^ E_NOTICE); 					// Switch Error-Messages off

$bin          = strval($_POST["bin"]);					// Getting the recent binary number
$old          = strval($_POST["old"]);					// Getting the earlier binary number
$row          = intval($_POST["row"]);					// Getting the amount of choices
$show_even	  = strval($_POST["show_even"]);			// Showing evens or only odds

if (!$bin) { $loop = loop_select(); $bin = "1";}		// Default binary  number (start)
if (!$row) { $row = 7; }								// Default amount of choices
if ($bin == "add")  { $row++; $bin = $old; }			// Add amount of choices
if ($bin == "sub")  { $row--; $bin = $old; }			// Reducing amount of choices
if (!$show_even)    { $show_even   = "false"; }			// Default showing only odds

$dec    = gmp_init($bin,2);								// GMP number of bin
$decmod = gmp_mod($dec,"3");							// n mod 3 (check, if n is a triple)
$old    = $bin;											// saving the binary number

if ( $decmod == "2" ) { 								// if n mod 3 = 2
	$decNew  = gmp_add($dec,gmp_div(gmp_add($dec,"1"),"3")); 	// first choice = n + (n + 1) / 3
}
if ( $decmod == "1" ) { 								// if n mod 3 = 1
	$decNew  = gmp_sub($dec,gmp_div(gmp_sub($dec,"1"),"3"));  	// first choice = n - (n - 1) / 3
}														// if n mod 3 = 0 (triple)
if ( $decmod == "0" ) { $decNew  = "0"; }				// no choice

$decNewmod = gmp_mod($decNew,"3");						// first choice mod 3

if ( $decNewmod == "0" ) { 								// if first choice is a triple
	$tri = "class='triples'";							// mark choice as triple
} else {												// else
	$tri = "";											// do not mark choice
}

if ($decNew <> "0") {									// if there is a choice
	$bin = gmp_strval($decNew,2);						// generate binary number of the choice
	$select = gen_select($decNew, $row-1);				// generate further coices
} else { 												// else
	$bin = $old;										// use the saved binary number
	$decNew = "Triple - <button onclick='history.back()'>back</button>"; // output for going back
}

/*
HTML for the form
*/
?> 

<html> 
  <head> 
    <meta charset="utf-8">
    <title>Sequence builder 3n-1</title>
	<style>

      td, th { 
		border: 1px solid;
		font-family: Courier;
		font-size: 12px;
		}
	  tr:hover {
		  background-color: #ddd;
	  }
	  td.triples{
		  background-color: #0f0;
	  }

    </style>
	
  </head>
  <body>
  <h3>Sequence builder 3n-1<h3>
  
<?php
if ($loop) { 											// Output to select a loop
	echo "<h4>Select loop:</h4>";
} 
?>
  
<form name="Formular" action="" method="POST">
<input type="hidden" name="row" value="<?php if ( $row ) { echo $row; } else { echo "7"; } ?>">
<input type="hidden" name="old" value="<?php if ( $old ) { echo $old; } else { echo "1"; } ?>">
<table border="1">
<?php
if ($loop) { 											// Output to select a loop
	echo $loop; 										// Output to select a loop
	$select = true;
} else {												// else, Output to select the next number
?>

	<tr>
		<td align="right" width="200" <?php echo $tri; ?>>
			<input type="radio" name="bin" value="<?php echo $bin; ?>" checked>
		</td>
		<td width="200" <?php echo $tri; ?> >
			<?php echo $decNew; ?>
		</td>
		<td width="200" <?php echo $tri; ?>>
			<?php echo $bin; ?>
		</td>
	</tr>
	<?php echo $select; 
	if ($select) {
	?>
	
	<tr>
		<td  align="right">
			<input type="radio" name="bin" value="add" >
		</td>
		<td>
			Add another possibility
		</td>
		<td>
			&nbsp;
		</td>
		
	</tr>
	<tr>
		<td  align="right">
			<input type="radio" name="bin" value="sub" >
		</td>
		<td>
			Reduce possibility
		</td>
		<td>
			&nbsp;
		</td>
		
	</tr>
	<tr>
		<td>
			Show even:
		</td>
		<td>
			Yes <input type="radio" name="show_even" value="true"  <?php if ( $show_even == "true"  ) { echo "checked"; } ?> >
			No <input type="radio" name="show_even" value="false"  <?php if ( $show_even == "false" ) { echo "checked"; } ?> >
		</td>
		<td>
			<button onclick='history.back()'>back</button>
		</td>
	</tr>
	<?php } ?>
	<?php } ?>
	<tr>
		<td>
			&nbsp;
		</td>
		<td>
		<?php if ($select) { ?>
			<input type="submit" value=" Send " />
		<?php } else {
			echo $decNew;
		}?>
		</td>
		<td>
			</form> <a href="">Reset</a>
		</td>
	</tr>
</table>

<?php
if ($loop) { 								// If to select a loop, stop the script
	die; 
} 

$bin = $old;
$i=1;										// set the iteration start
echo "<table border=\"1\">";
echo "<tr><th>Iteration</th><th>Decimal</th><th>Binary</th></tr>\n";
echo "<tr><td width='100'>".$i.".</td><td width='100'>".$dec."</td><td width='100' align='right'>".$bin."</td></tr>\n";

while($i <= 3000) {							// starting the iteration for the selected number
	$i++;
	$decmod = gmp_mod($dec,"2");			// n mod 2 - test, if n is odd or even
	if ($decmod == "0") {					// if n is even
		$bin = instr_even($bin);			// executing n / 2
	} else {								// if n is odd
		$bin = instr_odd($dec);				// executing n * 3 + 1
	}
	$dec = gmp_init($bin,2);				// generating the decimal number of the result
	$decmod = gmp_mod($dec,"2");	 		// test, if the the new result is even

	if ($show_even == "true" AND $decmod == "0") { 	// if the new result is even and showing even is selected, output of the result
		echo "<tr><td width='100'>".$i.".</td><td width='100'>".$dec."</td><td width='100' align='right'>".$bin."</td></tr>\n";
	} 
	if ($decmod == "1") {							// if the new result is odd, output of the result
		echo "<tr><td width='100'>".$i.".</td><td width='100'>".$dec."</td><td width='100' align='right'>".$bin."</td></tr>\n";
	}
	
	if ( $dec == "1" OR $dec == "5" OR $dec == "17" ) { // if the end of a loop is reached, stop
		break 1;
	}

}

echo "</table>";

function instr_even($bin) {						// executing the instruction for even numbers (using binary input)
	$bin = substr($bin, 0, -1);					// delete the last 0
	return $bin;
}

function instr_odd($dec) {						// executing the instruction for odd numbers (using decimal input)
	$dec    = gmp_sub(gmp_mul($dec,"3"),"1");	// n * 3 - 1
	$bin    = gmp_strval($dec,2);				// converting to a binary number
	return $bin;
}

function gen_select($dec, $row) {					// generating the output for further choices (using decimal input)
	while ($i < $row) {								// repeating the instruction for $row choices
		$dec    = gmp_sub(gmp_mul($dec,"4"),"1");	// another choice = first choice * 4 - 1
		$decmod = gmp_mod($dec,"3");				// next choice mod 3 (test, if next choice is a triple)
		if ($decmod == "0") { 						// if choice is a triple
			$tri = "class='triples'";				// mark choice
		} else {									// else
			$tri = "";								// do not mark choice
		}
		$bin    = gmp_strval($dec,2);				// convert choice to a binary number
		// ------------------------------------------- Output for the form to make the coice
		$gen .= '<tr>
			<td align="right" width="200" '.$tri.'>
				<input type="radio" name="bin" value="'.$bin.'">
			</td>
			<td width="200" '.$tri.'>
				'.$dec.'
			</td>
			<td width="200" '.$tri.'>
				'.$bin.'
			</td>
		</tr>';
		$i++;
	}
	return $gen;
}

function loop_select() {							// Output for the loops 1, 5 and 17
	$loop='
	<tr>
		<td align="right" width="200">
			<input type="radio" name="bin" value="1" >
		</td>
		<td width="200">
			1
		</td>
		<td width="200">
			1
		</td>
	</tr>
	<tr>
		<td align="right" width="200">
			<input type="radio" name="bin" value="101" >
		</td>
		<td width="200">
			5
		</td>
		<td width="200">
			101
		</td>
	</tr>
	<tr>
		<td align="right" width="200">
			<input type="radio" name="bin" value="10001" >
		</td>
		<td width="200">
			17
		</td>
		<td width="200">
			10001
		</td>
	</tr>';
	
	return $loop;
}

?>