<?php
/***********************************************************************************
Script purpose: Construction of a map for numbers within 3n-1 sequences
Written by:		Joerg Drescher, iovialis@gmx.de
Date: 			31.03.2022
Link: 			https://3n-1.de/map_3n-1.php
Lizence: 		CC BY-SA - https://creativecommons.org/licenses/by-sa/4.0/
***********************************************************************************/
error_reporting (E_ALL ^ E_NOTICE); 				// Switch Error-Messages off

$col          = intval($_POST["col"]);				// Getting columns
$row          = intval($_POST["row"]);				// Getting rows
$triples	  = strval($_POST["triples"]);			// Mark triples

if (!$col)     { $col      = 5;      }				// Default columns
if ($col == 0) { $col      = 1;      }				// if there is no column, set column to 1
if (!$row)     { $row      = 2000;   }				// Default rows
if (!$triples) { $triples  = "true"; }				// Default show triples

/*
HTML for the form
*/
?>

<html> 
  <head> 
    <meta charset="utf-8">
    <title>Map for 3n-1</title>
	<style>

	td, th { 
		border: 1px solid;
		font-family: Courier;
		font-size: 12px;
	}
	tr:hover {
		background-color: #ddd;
	}
	td.triples{
		background-color: #0f0;
	}

    </style>
	
  </head>
  <body>
  <h3>Map for 3n-1<h3>
<form name="Formular" action="" method="POST">
<table border="1">
	<tr>
		<td align="right" width="150">
			Map Size (columns):
		</td>
		<td>
			<input name="col" type="text" size="100" maxlength="10" value="<?php echo $col; ?>" >
		</td>
	</tr>
	<tr>
		<td align="right" width="150">
			Map Size (rows):
		</td>
		<td>
			<input name="row" type="text" size="100" maxlength="10" value="<?php echo $row; ?>" >
		</td>
	</tr>
	<tr>
		<td align="right" width="150">
			Mark triples:
		</td>
		<td>
			Yes <input type="radio" name="triples" value="true"  <?php if ( $triples == "true"  ) { echo "checked"; } ?> >
			No  <input type="radio" name="triples" value="false"  <?php if ( $triples == "false" ) { echo "checked"; } ?> >
		</td>
	</tr>
	<tr>
		<td>
			&nbsp;
		</td>
		<td>
			<input type="submit" value=" Send " />
			</form>
		</td>
	</tr>
</table>

<?php
$i=0;										// variable for columns
$col=$col-1;								// Columns adaptive
$colsize = $col+1;							// Colspan
echo "<table border='1'>";
echo ";<th><b>n</b></th><th colspan='".$colsize."'><b>(n*(2^x)+1)/3 (even x)</b></th><th colspan='".$colsize."'><b>(n*(2^x)+1)/3 (odd x)</b></th>";
$k=1;										// Counter for rows (and base for n)
while($k <= $row) {							// loop for rows
	if ($k % 3 == 2) {						// Check, if n mod 3 = 2
		$i      = $k + ( $k + 1 ) / 3;		// if so, calculate the second column (n + ( n + 1 ) / 3
		$tri    = "";						// mark n as non-triple
		$modu   = "<td colspan='".$colsize."'>&nbsp;</td>";		// Second column
		$mod1   = "";						// Third column
	}
	if ($k % 3 == 1) {						// Check, if n mod 3 = 1
		$i      = $k - ( $k - 1 ) / 3;		// if so, calculate the second column (n - ( n - 1 ) / 3
		$tri    = "";						// mark n as non-triple
		$modu   = "";						// Second column
		$mod1   = "<td colspan='".$colsize."'>&nbsp;</td>";		// Third column	
	}
	if ($k % 3 == 0) {						// Check, if n mod 3 = 0 (n is a triple)
		$i      = 0;						// set colums to empty
		$modu   = "<td colspan='".$colsize."'>&nbsp;</td>";		// Second column
		$mod1   = "<td colspan='".$colsize."'>&nbsp;</td>";		// Third column
		if ($triples == "true") {			// Check, if triples are marked
			$tri    = "class='triples'";	// mark n as triple
		}
	}
	if ($i % 3 == 0 AND $triples == "true" ) {			// Check, if n is a triple and if triples are marked
		$tri_i  = "<td class='triples'>".$i." </td>";	// mark n as triple in the first column (output)
	} else {											
		$tri_i  = "<td>".$i."</td>";					// output of the first column (triple not marked)
	}
	if ($i == 0 )  { $tri_i = ""; }						// if the first column is a triple, set all other colums empty
	if ($col > 1 ) {									// if there is more than two colums
		$row_output = row_gen($i, $col, $triples);		// generate the output for other colums
	}
	echo "<tr><td ".$tri." ><b>".$k."</b></td>".$modu.$tri_i.$row_output.$mod1."</tr>\n";	// output of the result
	
	$k = $k+2;											// increase n by 2 (only odd numbers)
}
echo "</table>";

function row_gen($k, $col, $triples) {					// function to generate the output for other colums
	if ($k <> 0) {										// if the second colum does not contain a triple
		while ($i < $col) {								// calculate the next colums
			$k = $k * 4 - 1;							// instruction for the next column
			if ($k % 3 == 0 AND $triples == "true" ) {	// check, if the content of the next column is a triple and if triples are marked
				$tri  = "class='triples'";				// if so, mark triple
			} else {									// else
				$tri  = "";								// do not mark
			}
			$row_output .= "<td ".$tri." >".$k." </td>";	// output for the row
			$i++;											// increase counter for columns
		}
	}
	return $row_output;
}

?>
